/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module pes.dump;
// dump

import std.stdio;
import std.cstream;
import std.ctype;

void hexdump(void[] buff)
{
	char c;
	char[16] graph;
	uint line, i;
	
	for (line = i = 0; i < buff.length; ++i) {
		c = (cast(char[])buff)[i];
		
		if (i % 16 == 0) {
			if (i) {
				dout.writeLine(" " ~ graph);
			}
			dout.printf("%08lX  ", line);
			line += 16;
		}
		dout.printf("%02X ", c & 0xff);
		if (isgraph(c)) {
			graph[i % 16] = c;
		} else {
			graph[i % 16] = '.';
		}
	}
    
	if (i && i % 16 != 0) {
		for (int j = 0; j < 16 - (i % 16); ++j) {
			dout.writeString("   ");
		}
		dout.writeString(" " ~ graph[0 .. i % 16]);
	}
	dout.writeString("\n");
	dout.flush();
}

void arraydump(void[] buff)
{
	char c;
	char[16] graph;
	uint line, i;
	
	for (line = i = 0; i < buff.length; ++i) {
		c = (cast(char[])buff)[i];
		
		if (i % 16 == 0) {
			if (i) {
				dout.writeLine(" " ~ graph);
			}
			dout.printf("%08lX  ", line);
			line += 16;
		}
		dout.printf("0x%02X, ", c & 0xff);
		if (isgraph(c)) {
			graph[i % 16] = c;
		} else {
			graph[i % 16] = '.';
		}
	}
    
	if (i && i % 16 != 0) {
		for (int j = 0; j < 16 - (i % 16); ++j) {
			dout.writeString("   ");
		}
		dout.writeString(" " ~ graph[0 .. i % 16]);
	}
	dout.writeString("\n");
	dout.flush();
}

void bindump(ubyte[] buff)
{
	dout.writeBlock(buff, buff.length);
}

