﻿/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module pes.file;

protected import std.file;
private import std.utf;
private import pes.checksum;

// ファイル操作

version(Win32)
{
	private import std.c.windows.windows;
	
	extern (Windows) 
		BOOL SetFileAttributesW(void *, DWORD);
	
	extern (Windows)
		BOOL SetFileAttributesA(void *, DWORD);
}
version(linux)
{
	private import std.c.linux.linux;
}

void forcedRemoveFile(char[] path)
{
	int result;
	
	version(Win32) {
		if (std.file.useWfuncs) {
			result = SetFileAttributesW(toUTF16z(path), FILE_ATTRIBUTE_NORMAL);
		} else {
			result = SetFileAttributesA(toMBSz(path), FILE_ATTRIBUTE_NORMAL);
		}
	}
	version(linux) {
	}
	
	std.file.remove(path);
}

bool isDifferent(char[] filepath, ubyte[] hash)
{
	ubyte[] sum = md5FileSum(filepath);
	
	return sum != hash;
}

bool isDifferent(char[] filepath1, char[] filepath2)
{
	ubyte[] sum1 = md5FileSum(filepath1);
	ubyte[] sum2 = md5FileSum(filepath2);
	
	return sum1 != sum2;
}

